   package jk.micro;
   import robocode.*;
   import robocode.util.*;
   import java.awt.geom.*;
   import java.util.*;
   import java.awt.*;

/*
*Toorkild - a second attempt at multiple-choice pattern-matching by Skilgannon (Julian Kent)
*Special features:
** never finds the same 'match' twice, even with different key-lengths
** weights the multiple choice depending on the match length
** finds up to 30 different matches
** matches on lateral velocity and advancing velocity
** still manages to fit in Waylander's strong StopAndGo/Random multi-movement
*/


    public class Toorkild extends AdvancedRobot
   {
   
   
      static final int BINS = 230;// full 360 degrees of bins - not just in the reachable range
      static final int MAX_MATCHES = 50;
      
      //static final char ROUND_BREAK = ((char)(((-127)<<8)|(0xFF&((byte)(-127)))));
   
   
      static StringBuilder staticData = new StringBuilder();
      static double bulletVelocity;
      static double direction = 1;
      static double lastEnemyEnergy;
      static boolean flat;
     
   	
       public void run() {
         
      	//NOT NECESSARY FOR 35 ROUND BATTLES - CAN BE REMOVED FOR 15 EXTRA CODESIZE
         // try{
            // staticData.delete(60000, 80000);
         // }
             // catch(Exception e){}
         //staticData.insert(0,ROUND_BREAK);
             
         setAdjustRadarForGunTurn(true);
         //setAdjustRadarForRobotTurn(true); -- redundant
         setAdjustGunForRobotTurn(true);
         
         while(true){
            turnRadarRight(Double.POSITIVE_INFINITY);
         }
      	
      }
   
   
       public void onScannedRobot(ScannedRobotEvent e) {
         
         StringBuilder data = staticData;
         
         double eOffset;
         double absbearing=e.getBearingRadians()+ getHeadingRadians();
         double eDistance ;
         boolean rammer = (eDistance = e.getDistance()) < 100;// || getTime() < 20; 
          
      //movement \/  \/
         double goAngle;
         eOffset =( Math.PI/2 + 1*0.8) - eDistance*(0.8/600);
         
         while(! new Rectangle2D.Double(18,18,764,564).
         contains(getX() + 160 * Math.sin(goAngle = absbearing + direction * (eOffset -= .02)), getY() + 160 * Math.cos(goAngle))
         );
      
         
         if((flat && !rammer && 
         Math.random() <  0.6*Math.sqrt(bulletVelocity/eDistance) - 0.04
         ) || 
          eOffset < Math.PI/4 ) {
            direction = -direction;
         }
         setTurnRightRadians(Math.tan(goAngle -= getHeadingRadians()));
         
         eOffset = (lastEnemyEnergy - (lastEnemyEnergy = e.getEnergy()));
         
         if((0  < eOffset && eOffset <= 3) || flat || rammer){
            setAhead((37 + ((int)(eOffset - 0.50001))*11) * Math.signum(Math.cos(goAngle)));
         }
         
      	// MOVEMENT /\   /\   /\  
      	
      	
      	// GUN \/    \/   \/
         
         // data.insert(0,(char)Math.round(e.getVelocity()*Math.sin(eOffset)))
            //    .insert(0,(char)(Math.round(e.getVelocity()*Math.cos(eOffset))));
            
      ////BITSHIFTING!!!!!! THE NEW TECHNOLOGY!! ;-) should find matches twice as fast
      //// because there are half as many characters. 
         data.insert(0,(char)(((int)Math.round(e.getVelocity()*Math.sin(eOffset = e.getHeadingRadians()- absbearing))<<8)|
            (0XFF&((byte)Math.round(e.getVelocity()*Math.cos(eOffset))))));
         
         double bulletPower = rammer?3:Math.min(2,Math.min(getEnergy()/16, lastEnemyEnergy/2));
      
         int keyLength = Math.min(data.length(), Math.min((int)getTime(), 66));
         int indexSize = 0;
         int[] index = new int[MAX_MATCHES];
         int tempIndex = 0;
         int[] bins = new int[BINS]; 
         do{
            do{
               if( tempIndex < 0 )
                  keyLength= keyLength*3/4;
                  // keyLength/=2;
            
               tempIndex = data.indexOf(
                  data.substring(0, keyLength),Math.max(((int)eDistance)/11,tempIndex + 1));
            
            }while((tempIndex < 0  || Arrays.binarySearch(index,tempIndex) >= 0/*(contains(index, tempIndex) )*/) && keyLength > 0);	
            if(keyLength == 0)
               break;
            int iterateIndex = index[index.length - ++indexSize] = tempIndex;
            Arrays.sort(index);
            double db=0;
            eOffset = 0;
            double dist = eDistance;
            char comboChar;
            do
            {
              
               comboChar = data.charAt(iterateIndex--);
               //if(comboChar == ROUND_BREAK)
                //  break;  
            	
               eOffset += (byte)(comboChar>>8)/dist;
               dist += (byte)(comboChar&0XFF);    
               
            
            }while ((db+=Rules.getBulletSpeed(bulletPower)) < dist && iterateIndex > 0); 
            //if(comboChar != ROUND_BREAK)
            bins[(int)Math.round(Utils.normalAbsoluteAngle(eOffset)*((BINS - 1)/(2*Math.PI)))]+= keyLength;
         
         }while(indexSize < index.length);
         
                      
         
         keyLength = BINS - 1;
         tempIndex = 0;
         do{
            if(bins[keyLength] > bins[tempIndex])
               tempIndex = keyLength;
         }
         while(keyLength-- > 0);
            
         setTurnGunRightRadians(Utils.normalRelativeAngle(absbearing 
            + Math.signum(Math.random() - 0.5)/eDistance 
            + tempIndex*(2*Math.PI/(BINS - 1)) - getGunHeadingRadians()));
         setFire(bulletPower);
         setTurnRadarRightRadians(Math.sin(absbearing - getRadarHeadingRadians())*2);
      	
         // gun /\  /\
      
      }
   	
       public void onHitByBullet(HitByBulletEvent e){
         lastEnemyEnergy += 20 - (bulletVelocity = e.getVelocity());	
      }
   
       public void onDeath(DeathEvent e){
       
         if(getRoundNum() < 3)
            flat = true;
      
      }
       public void onBulletHit(BulletHitEvent e){
         lastEnemyEnergy -= Rules.getBulletDamage(e.getBullet().getPower());
         // lastEnemyEnergy -= 10;
         
      }
       // public static boolean contains(int[] set, int value){
         // int i = 0;
         // do{
            // if(set[i] == value)
               // return true;
         // }while( ++i < set.length);
      // 
         // return false;
      // }
        
   }